function obj = classcutComputeEntireImageSegmentation(paramsClassCut,segm_labels)

origDir = [pwd '/'];


cd(paramsClassCut.workingDir);
structTemp = load('obj.mat');
obj = structTemp.obj;

if ~ isfield(obj,'name')
    obj = classcutUpdateObj(paramsClassCut,obj);
end
obj = as_SetSegmentsValue(obj,'solution',segm_labels);

cd(paramsClassCut.inputDir);
images = dir(['*.' paramsClassCut.imageType]);

for idx = 1:length(obj) 
    
    imgPartialSegm = mgc_DeriveImgFromSetSegms(obj(idx),'fg');
    i_base = images(idx).name(1:end-length(paramsClassCut.imageType)-1);        
    
    struct = load([paramsClassCut.inputDir  '/' i_base '_bbox.mat']);
    bbox = struct.bbox;
    xmin = bbox(1);
    xmax = bbox(3);
    ymin = bbox(2);
    ymax = bbox(4);
    
    img = imread(images(idx).name);
    obj_predicted_contour = zeros(size(img,1),size(img,2));
    imgFullSegm = zeros(size(img,1),size(img,2));
    
    obj_predicted_contour(ymin,xmin:xmax) = ones(1,xmax-xmin+1);
    obj_predicted_contour(ymax,xmin:xmax) = ones(1,xmax-xmin+1);    
    obj_predicted_contour(ymin:ymax,xmin) = ones(ymax-ymin+1,1);
    obj_predicted_contour(ymin:ymax,xmax) = ones(ymax-ymin+1,1);
    
    obj(idx).segmentation.partial = imgPartialSegm;    
        
    obj(idx).base_name = i_base;
    
    imgFullSegm(ymin:ymax,xmin:xmax) = imresize(imgPartialSegm,[ymax-ymin+1 xmax-xmin+1],'bilinear');

    imgFullSegm = round(imgFullSegm);    
    
    obj(idx).segmentation.partial = imgPartialSegm;    
    obj(idx).segmentation.full_image = imgFullSegm;    
    obj(idx).segmentation.obj_predicted_contour = obj_predicted_contour; 
    
end

cd(origDir);