function I = classcutComputeGradientBorder(I,adj_type,verbose)

gradient_type = ['gradient_' adj_type];

if nargin < 3
  verbose = false;
end
for ix = 1:length(I)
  A = I(ix).(adj_type);%adjacency matrix
  segms = I(ix).segms;
  I(ix).(gradient_type) = zeros(length(segms),length(segms));  % logical array -> spare memory !
  for six1 = 1:length(segms)
    for six2 = (six1+1):length(segms);
        if(A(six1,six2))
            C1 = segms(:,six1).perim_coords;
            C2 = segms(:,six2).perim_coords;
            [ind dists2] = vgg_nearest_neighbour(double(C1), double(C2));
            ind_n = find(dists2==1);
            C1_n = C1(:,ind_n);
            sum_temp = 0;
            for jj=1:size(C1_n,2)
                sum_temp = sum_temp + I(ix).pbblurred(C1_n(2,jj),C1_n(1,jj));
            end
            I(ix).(gradient_type)(six1,six2) = sum_temp/length(C1_n);
            
            [ind dists2] = vgg_nearest_neighbour(double(C2), double(C1));
            ind_n = find(dists2==1);
            C2_n = C2(:,ind_n);
            
            sum_temp = 0;
            for jj=1:size(C2_n,2)
                sum_temp = sum_temp + I(ix).pbblurred(C2_n(2,jj),C2_n(1,jj));
            end
            I(ix).(gradient_type)(six2,six1) = sum_temp/length(C2_n);
            
            if verbose
                figure; hold on;
                C1 = segms(:,six1).perim_coords;
                C2 = segms(:,six2).perim_coords;
                plot(C1(1,:), C1(2,:), 'bo');
                plot(C2(1,:), C2(2,:), 'ro');
                plot(C1_n(1,:),C1_n(2,:), 'go');
                plot(C2_n(1,:),C2_n(2,:), 'go');
                axis ij; axis equal;
                disp(['segments ' num2str(six1) ', ' num2str(six2) ' -> gradient = ' num2str(I(ix).(gradient_type)(six1,six2))]);
                disp(['segments ' num2str(six2) ', ' num2str(six1) ' -> gradient = ' num2str(I(ix).(gradient_type)(six2,six1))]);
                keyboard;
            end
    end % loop over s2
  end % loop over s1
end % loop over images


end