function resultStruct = classcutDrawSegmentationsEachIterations(paramsClassCut,segm_labels,shape_model,location_model)


org_dir = pwd;
org_ldlp = getenv('LD_LIBRARY_PATH');
setenv('LD_LIBRARY_PATH', '');

weights = paramsClassCut.weights;

cd(paramsClassCut.workingDir);


structTemp = load('obj.mat');
obj = structTemp.obj;
images = dir(['*.' paramsClassCut.imageType]);

resultsRoot = 'Results';
mkdir(resultsRoot);
cd([paramsClassCut.workingDir '/' resultsRoot '/']);

folder_name = [];
for w = weights
    folder_name = [folder_name strrep(num2str(w),'.','_') '--'];
end
folder_name = folder_name(1:end-2);
mkdir(folder_name);
cd([paramsClassCut.workingDir '/' resultsRoot '/' folder_name '/']);


for iteration = 2:size(segm_labels,1)
    
    obj = mgc_SetSegmentsFgBgFromSolution(obj,segm_labels(iteration,:));        
    cd([paramsClassCut.workingDir '/' resultsRoot '/' folder_name '/']);    
    iter_folder_name = ['Iteration--' num2str(iteration)];
    mkdir(iter_folder_name);
    cd(iter_folder_name);
    
    img_id = 0;
    for i = images'
        img_id = img_id + 1;
        pos = strfind(i.name,'CroppedNormMedian');
        i_base = i.name(1:pos(end)-1);
        img_obtained = zeros(size(obj(img_id).pb));
        for sid = 1:length(obj(img_id).segms)
            if(obj(img_id).segms(sid).fg)
                for jj=1:length(obj(img_id).segms(sid).coords)
                    x = obj(img_id).segms(sid).coords(1,jj);
                    y = obj(img_id).segms(sid).coords(2,jj);
                    img_obtained(y,x)=1;
                end
            end
        end        
        imwrite(img_obtained,[i_base '.' paramsClassCut.imageType],paramsClassCut.imageType);
    end               
end

cd([paramsClassCut.workingDir '/' resultsRoot '/' folder_name '/']);
resultStruct.shape_model = shape_model;
resultStruct.location_model = location_model;
save('shape_model.mat','shape_model');
save('location_model.mat','shape_model');
save('segm_labels.mat','segm_labels');

obj = classcutComputeEntireImageSegmentation(paramsClassCut,segm_labels(end,:));
folder_name = 'Final--Image-Segmentations';
mkdir(folder_name);
cd(folder_name)


img_id =0;

for i = images'
    img_id = img_id + 1;
    pos = strfind(i.name,'CroppedNormMedian');
    i_base = i.name(1:pos(end)-1);    
    imwrite(obj(img_id).segmentation.full_image,[i_base '_final_image_segm.' paramsClassCut.imageType],paramsClassCut.imageType); 
    resultStruct.segmentations{img_id} = obj(img_id).segmentation.full_image;
end
    
resultStruct.segm_dir = [pwd '/'];


cd(org_dir);
setenv('LD_LIBRARY_PATH', org_ldlp);
