function bb = classcutFindCoordinateFrame(img,paramsClassCut)

%determine the coordinate frame using the objectness measure - Alexe CVPR10

mask = paramsClassCut.mask;

cd([paramsClassCut.soft_dir '/objectness-release/']);
windows = runObjectness(img,paramsClassCut.nbSamplesObjectness);

windows(:,1) = max(round(windows(:,1)),1);
windows(:,2) = max(round(windows(:,2)),1);
windows(:,3) = min(round(windows(:,3)),size(img,2));
windows(:,4) = min(round(windows(:,4)),size(img,1));

objMap = zeros(size(img,1), size(img,2));

for idx = 1:size(windows)
    
    xmin = windows(idx,1);
    ymin = windows(idx,2);
    xmax = windows(idx,3);
    ymax = windows(idx,4);
       
    maskResized = imresize(mask,[ymax-ymin+1 xmax-xmin+1],'bilinear');
    
    maskBox = zeros(size(img,1), size(img,2));
    maskBox(ymin:ymax,xmin:xmax) = maskResized;

    objMap = objMap + maskBox * windows(idx,5);
    
end

bbox = regionprops(objMap > paramsClassCut.thresholdobjectness,'BoundingBox');

bb = bbox.BoundingBox;    
bb(3) = bb(1) + bb(3);    
bb(4) = bb(2) + bb(4);