function classcutGetCroppedImages(inputDir,outputDir,imageType)

% all images from inputDir are cropped to the bbox containing the coordinate frame

origDir = pwd;
org_ldlp = getenv('LD_LIBRARY_PATH');
setenv('LD_LIBRARY_PATH', '');

cd(inputDir);
images = dir(['*.' imageType]);

for i = images'
      
    name = i.name;
    imgBase = name(1:(length(name)-length(imageType)-1));
    nameImgCroppedFull = [imgBase 'Cropped.' imageType]; 
    
    if not(exist([pwd '/' nameImgCroppedFull], 'file'))
    
        %load the coordinate frame
        tempStruct = load([imgBase '_bbox.mat' ],'bbox');
        bbox = tempStruct.bbox;
        xmin = bbox(1);
        ymin = bbox(2);
        xmax = bbox(3);
        ymax = bbox(4);
        
        img = imread(i.name);
        imgCropped = img(ymin:ymax,xmin:xmax,:);
        nameImgCropped = [imgBase 'Cropped'];
        imwrite(imgCropped,[outputDir nameImgCropped '.' imageType],imageType);
    end
    
end

cd(origDir);
setenv('LD_LIBRARY_PATH', org_ldlp);
end