function [obj  prob_llhood_bg prob_llhood_fg] = classcutGetDataPreprocessedSoftMaskFromClasses(paramsClassCut)

%get the initial object structure and
%the likelihoods for the first iteration

org_dir = pwd;
org_ldlp = getenv('LD_LIBRARY_PATH');
setenv('LD_LIBRARY_PATH', '');

grid_dist = paramsClassCut.grid_dist;

cd(paramsClassCut.workingDir);
struct = load('obj.mat');
obj = struct.obj;
option_init = 'soft_mask_lfc';
obj_fname = ['obj_init_' strrep(option_init,' ','_') ];

try
    obj_fname = ['obj_init_' strrep(option_init,' ','_') ];
    struct = load(obj_fname);
    obj = struct.obj;
    prob_llhood_bg = struct.prob_llhood_bg;
    prob_llhood_fg = struct.prob_llhood_fg;
catch   
    soft_mask = paramsClassCut.mask;
        
    cd(paramsClassCut.workingDir);
    
    for app_idx = 1:length(paramsClassCut.codebook_size)
        
        option_features = paramsClassCut.option_features{app_idx};
        kmeans_nb = paramsClassCut.codebook_size(app_idx);
        %quantizier = quantization{app_idx};
        
        if(strcmpi(option_features,'surf'))
            matrix_name = ['matrix_features_surf_' num2str(kmeans_nb) '_' num2str(grid_dist) '.mat'];             
        end
        
        structTemp = load(matrix_name,'matrix_features');
        matrix_features = structTemp.matrix_features;        
        
        if strcmpi(option_features,'surf')
            fname = ['CX_' num2str(kmeans_nb)];
            try
                load(fname);
            catch
                display([fname 'doesn''t exist']);CX = [];
            end
        else
            CX = [];
        end
                
        obj = mgc_AssignUnnormHistToSegm(obj,matrix_features,grid_dist,option_features,app_idx);
        
        [obj prob_bg prob_fg] = classcutInitModelBgFg(obj,paramsClassCut,option_features,grid_dist,CX);
        prob_llhood_bg{app_idx} = prob_bg;
        prob_llhood_fg{app_idx} = prob_fg;
    end
    save(obj_fname,'obj','prob_llhood_bg','prob_llhood_fg','-v7');
end


cd(org_dir);
setenv('LD_LIBRARY_PATH', org_ldlp);