function classcutGetNormMedianImages(inputDir,outputDir,imageType)

% normalize all images in the inputDir s.t. they have the same height (the median of the images heights)

org_dir = pwd;
org_ldlp = getenv('LD_LIBRARY_PATH');
setenv('LD_LIBRARY_PATH', '');

cd(inputDir);
images = dir(['*.' imageType]);
imgHeight = zeros(length(images),1);
currentImage = 0;

%initial test
existAll = 1;
for i = images'   
    name = i.name;
    imgBase = name(1:(length(name)-length(imageType)-1));
    nameImgNormMedianFull = [imgBase 'NormMedian.' imageType];    
    if not(exist([pwd '/' nameImgNormMedianFull], 'file'))
        existAll = 0;
    end
end

if existAll    
    return
end
    
        
        
for i = images'    
  currentImage = currentImage+1;    
  img = imread(i.name);    
  imgHeight(currentImage) = size(img,1);  
end

heights = sort(imgHeight);
medianHeight = heights(ceil((length(images)+1)/2));

currentImage = 0;
for i = images'   
    currentImage = currentImage+1;
    name = i.name;
    imgBase = name(1:(length(name)-length(imageType)-1));
    img = imread(i.name);
    imgNormMedian = imresize(img,[medianHeight NaN],'bilinear');    
    imwrite(imgNormMedian,[outputDir '/' imgBase 'NormMedian.' imageType],imageType);      
end

cd(org_dir);
setenv('LD_LIBRARY_PATH', org_ldlp);
end