function GM = classcutGetPairwiseLocationSmoothnessImagesReduced(obj)

nb_images = length(obj);
img_segms = zeros(1, nb_images);

width = [];
for i = 1: nb_images
    img_segms(i) = length(obj(i).segms);
    width = [width; size(obj(i).pb,2)];
end

height = size(obj(i).pb,1);
width = median(width);

for img_id = 1:nb_images      
    for sid = 1:length(obj(img_id).segms)
        mask_sp = zeros(size(obj(img_id).pb));
        points = obj(img_id).segms(sid).coords;        
        mask_sp((points(1,:)-1)*height + points(2,:)) = 1;       
        mask_sp = imresize(mask_sp,[height width],'bilinear');
        mask_sp(mask_sp > 0.5) = 1;        
        obj(img_id).segms(sid).mask = mask_sp;
    end
end

total_segms = sum(img_segms);
NUMPW = total_segms * (total_segms-1)/2;

GM.state = 'LocationSmoothnessImages - pairwise';
GM.PI=zeros(3,NUMPW);   
GM.PE=cell(1,NUMPW);
GM.UE=cell(1,total_segms);

idx = 0;
for img = 1:total_segms    
    for jmg = img+1:total_segms        
        idx = idx+1;
        GM.PI(:,idx) = [img jmg idx];
        GM.PE{idx} = double(zeros(2,2));
    end    
    GM.UE{img} = double([0 0]);
end
GM.PI = uint32(GM.PI);
contor = 0;
tic
for i = 1:nb_images-1     
    %i
    trash = 0;
    %tic
    for ii = 1: img_segms(i)        
        for j = i+1:nb_images            
            for jj = 1: img_segms(j)   
                
                intersection = sum(sum(obj(i).segms(ii).mask .* obj(j).segms(jj).mask));                
               
                if not(intersection)
                    continue;
                end                
                contor = contor+1;
                union = sum(sum((obj(i).segms(ii).mask + obj(j).segms(jj).mask) > 0));
                penalty = intersection/union;
                
                %get the positions associated with variable b^i_ii and b^j_jj
                pos_i_ii = sum(img_segms(1:i-1))+ii; 
                pos_j_jj = sum(img_segms(1:j-1))+jj;                
                GM.PI(:,contor) = [pos_i_ii pos_j_jj contor];
                GM.PE{contor} = double(penalty * [0 1;1 0]);                                    
                trash = trash + 1;
            end
        end
    end
    %trash
    %toc
end
%toc
GM.PI = uint32(GM.PI);
GM.PI = GM.PI(:,1:contor);
GM.PE = GM.PE(1:contor);