function GM = classcutGetPairwiseSmoothnessGradientReduced(obj,alpha_gradient)

nb_images = length(obj);
img_segms = zeros(1, nb_images);

for i = 1: nb_images
    img_segms(i) = length(obj(i).segms);
end

total_segms = sum(img_segms);
NUMPW = total_segms * (total_segms-1)/2;

GM.state = 'SmoothnessGradient - pairwise';
GM.PI=zeros(3,NUMPW);   
GM.PE=cell(1,NUMPW);
GM.UE=cell(1,total_segms);

for img = 1:total_segms    
    GM.UE{img} = double([0 0]);
end

contor = 0;
for i = 1:nb_images        
    for ii = 1: img_segms(i)-1
        for iii = ii+1 : img_segms(i)            
            pos_i_ii = sum(img_segms(1:i-1))+ii; 
            pos_i_iii = sum(img_segms(1:i-1))+iii;                                 
            if(obj(i).adjacent(ii,iii))
                contor = contor+1;
                penalty = obj(i).adjacent(ii,iii) * exp(-alpha_gradient *0.5*(obj(i).gradient_adjacent(ii,iii) + obj(i).gradient_adjacent(ii,iii)));                
                GM.PI(:,contor) = [pos_i_ii pos_i_iii contor];
                GM.PE{contor} = double(penalty * [0 1;1 0]);
            end
        end
    end
end

GM.PI = uint32(GM.PI);
GM.PI = GM.PI(:,1:contor);
GM.PE = GM.PE(1:contor);