function classcutGetResizeOriginalImagesProportionalCroppedBBox(inputDir,outputDir,CroppedDir,CroppedNormMedianDir,imageType)

%for every img in inputDir(original images dir) resize it such that after
%the resizing the FG(GT) is the same as the cropped_median img in
%cropped_norm_meadian_dir
%resize wrt to height

origDir = pwd;
org_ldlp = getenv('LD_LIBRARY_PATH');
setenv('LD_LIBRARY_PATH', '');

cd(inputDir);
images = dir(['*.' imageType]);
bbox = cell(1,length(images));
currentImage = 0;

for i = images'    
  currentImage = currentImage+1;    
  name = i.name;    
  imgBase = name(1:(length(name)-length(imageType)-1));
  tempStruct = load([imgBase '_bbox.mat'],'bbox');
  bbox{currentImage} = tempStruct.bbox;  
end

cd(CroppedDir);
images = dir(['*.' imageType]);
imgHeightCropped = zeros(length(images),1);
currentImage = 0;

for i = images'    
  currentImage = currentImage+1;    
  img = imread(i.name);    
  imgHeightCropped(currentImage) = size(img,1);  
end

cd(CroppedNormMedianDir);
images = dir(['*.' imageType]);
imgHeightCroppedNormMedian = zeros(length(images),1);
currentImage = 0;

for i = images'    
  currentImage = currentImage+1;    
  img = imread(i.name);    
  imgHeightCroppedNormMedian(currentImage) = size(img,1);  
end

cd(inputDir);
images = dir(['*.' imageType]);
currentImage = 0;

for i =images'
    currentImage = currentImage+1; 
    name = i.name;
    imgBase = name(1:(length(name)-length(imageType)-1));
    img = imread(i.name);
    
    ratio = imgHeightCroppedNormMedian(currentImage)/imgHeightCropped(currentImage);
    height_resized = round(size(img,1) * ratio);
    img_resized = imresize(img,[height_resized NaN],'bilinear'); 
    imwrite(img_resized,[outputDir '/' imgBase '_resized.' imageType],imageType);      
    bbox_resized = round(bbox{currentImage} * ratio);
    save([outputDir '/' imgBase '_bbox_resized'],'bbox_resized');
    
end


cd(origDir);
setenv('LD_LIBRARY_PATH', org_ldlp);