function GM = classcutGetUnaryGlobalAppGM(obj,prob_bg,prob_fg,id_cell)

nb_images = length(obj);
img_segms = zeros(1, nb_images);

for i = 1: nb_images
    img_segms(i) = length(obj(i).segms);
end

total_segms = sum(img_segms);

GM.state = 'GlobalApp - unary';
GM.UE = cell(1,total_segms);
temp = mgc_UnaryNULL(obj);
GM.UE = temp.UE;
clear temp;

prob_bg = regularize_probability_vector(prob_bg);
prob_fg = regularize_probability_vector(prob_fg);
posterior_fg = prob_fg./(prob_fg + prob_bg);
posterior_bg = prob_bg./(prob_fg + prob_bg);

current_var = 0;

for img_id = 1:nb_images
    for segm_id = 1:length(obj(img_id).segms)
        current_var = current_var + 1;                  
            prob_fg_hist = computePosteriorFgHistogram(obj(img_id).segms(segm_id),posterior_fg,id_cell);
            prob_bg_hist = computePosteriorFgHistogram(obj(img_id).segms(segm_id),posterior_bg,id_cell);
            GM.UE{current_var} = -log([prob_bg_hist prob_fg_hist]);       
    end
end

end

function prob_fg_hist = computePosteriorFgHistogram(segm,posterior_fg,id_cell)

hist = segm.hist{id_cell};

if(sum(hist) == 0) %no feature extracted in this segment
    prob_fg_hist = 0.5;
    return
end

hist = hist/sum(hist);

prob_fg_hist = 1;
for word = 1:size(hist,1)
    if(hist(word))        
        prob_fg_hist = prob_fg_hist * (posterior_fg(word)^(hist(word)));
    end
end

end