function [obj initial_segms] = classcutGrabcutColorModelInitialization(paramsClassCut,obj)

%creates bg and fg fields for every segms in obj according to the proportion
%of the segments inluced in fg_prior

current_dir = pwd;
cd(paramsClassCut.full_images_resized)
mask = paramsClassCut.mask;
fg_prior = paramsClassCut.fg_prior;

for img_id = 1:length(obj)
    
    [i_base i_type] = getFilenameBaseType(obj(img_id).name);
    
    obj(img_id).name = [paramsClassCut.full_images_resized strrep(i_base,'CroppedNormMedian','_resized') '.' i_type];
    
    resized_img = imread(obj(img_id).name);
    new_image_segm = zeros(size(resized_img,1),size(resized_img,2));
    struct = load([strrep(i_base,'CroppedNormMedian','_bbox_resized') '.mat']);
    bbox = struct.bbox_resized;
    xmin = bbox(1);
    ymin = bbox(2);
    xmax = bbox(3);
    ymax = bbox(4);
    inner_img = zeros(ymax-ymin+1,xmax-xmin+1);
    
    resized_mask = imresize(mask,[size(inner_img,1) size(inner_img,2)],'bilinear');
    threshold = td_quantile(resized_mask,1-fg_prior);
    
    inner_img(resized_mask>=threshold) = 1;
    
    new_image_segm(ymin:ymax,xmin:xmax) = inner_img;
    obj(img_id).initial_segmentation = new_image_segm;    
end

initial_segms = cell(1,length(obj));

for idx = 1:length(obj)
    initial_segms{idx} = obj(idx).initial_segmentation;
end

cd(current_dir);