function [obj prob_llhood_bg prob_llhood_fg] = classcutInitModelBgFg(obj,paramsClassCut,option_features,grid_dist,CX)

%performs initialization of the fg and bg in images at the level of
%superpixels

cd(paramsClassCut.workingDir);
images = dir(['*.' paramsClassCut.imageType]);

soft_mask = paramsClassCut.mask;

if strcmpi(option_features,'surf')
    prob_llhood_bg = zeros(size(CX,2),1);
    prob_llhood_fg = zeros(size(CX,2),1);
end

for img_id = 1:length(obj)
    
    soft_mask_resized = imresize(soft_mask,size(obj(img_id).pb),'bilinear');
    
    if strcmpi(option_features,'surf')
        
        try
            
            if (length(obj)==1) %baseline
                fname = [num2str(obj(1).index_image) '_' option_features '_' num2str(size(CX,2)) '_map.mat'];
            else
                fname = [num2str(img_id) '_' option_features '_' num2str(size(CX,2)) '_map.mat'];
            end
            struct = load(fname);
            map = struct.map;
            
        catch            
            
            if(length(obj) == 1)%baseline
                i = images(obj(1).index_image);
            else
                i = images(img_id);
            end
            
            img = im2double(rgb2gray(td_imreadc([paramsClassCut.workingDir '/' i.name])));
            imgsize = size(img);
            
            pts = gengrid(imgsize(2),imgsize(1),[0.01 0.02 0.05],grid_dist);
            f = surfDes(img,pts);
            viswords = quantise(f',CX);
            
            map = zeros(imgsize(1),imgsize(2),3);
            
            dim_column = [ones(1,size(pts,1)/3) 2*ones(1,size(pts,1)/3) 3*ones(1,size(pts,1)/3)]';
            pts = [pts dim_column];
            
            for row = 1:size(pts,1)
                map(pts(row,2),pts(row,1),pts(row,end)) = viswords(row);
            end
            
            fname = [num2str(img_id) '_' option_features '_' num2str(size(CX,2)) '_map.mat'];
            save(fname,'map');
        end
        
        try
            if (length(obj)==1) %baseline
                fname = [num2str(obj(1).index_image) '_' option_features '_' num2str(size(CX,2)) '_outsidebox_map.mat'];
            else
                fname = [num2str(img_id) '_' option_features '_' num2str(size(CX,2)) '_outsidebox_map.mat'];
            end
            struct = load(fname);
            out_map = struct.out_map;
        catch
            
            if(length(obj) == 1)%baseline
                i = images(obj(1).index_image);
            else
                i = images(img_id);
            end
            
            i_base = i.name(1:end-length(paramsClassCut.imageType)-1);
            pos = strfind(i_base,'CroppedNormMedian');
            i_base = i_base(1:pos(end)-1);
            img = im2double(td_imreadc([paramsClassCut.full_images_resized '/' i_base '_resized.' paramsClassCut.imageType ]));
            imgsize = size(img);
            
            pts = gengrid(imgsize(2),imgsize(1),[0.01 0.02 0.05],grid_dist);            
            struct = load([paramsClassCut.full_images_resized '/' i_base '_bbox_resized.mat']);
            bbox = struct.bbox_resized;
            pts = mgc_EliminatePoints(pts,bbox);
            f = surfDes(img,pts);
            viswords = quantise(f',CX);
            
            out_map = zeros(imgsize(1),imgsize(2),3);
            
            dim_column = [ones(1,size(pts,1)/3) 2*ones(1,size(pts,1)/3) 3*ones(1,size(pts,1)/3)]';
            pts = [pts dim_column];
            for row = 1:size(pts,1)
                out_map(pts(row,2),pts(row,1),pts(row,end)) = viswords(row);
            end
            fname = [num2str(img_id) '_' option_features '_' num2str(size(CX,2)) '_outsidebox_map.mat'];
            cd(paramsClassCut.workingDir);
            save(fname,'out_map');
        end
        
        for word = 1:size(CX,2)
            for dim = 1:size(map,3)
                map_dim = map(:,:,dim);
                idx = map_dim == word;
                prob_llhood_bg(word) = prob_llhood_bg(word) + sum(1-soft_mask_resized(idx));
                prob_llhood_fg(word) = prob_llhood_fg(word) + sum(soft_mask_resized(idx));
            end
            %add outside box statistics for BG
            prob_llhood_bg(word) = prob_llhood_bg(word) + length(find(out_map == word));
        end
        
    end
    
    
    prob_llhood_bg = prob_llhood_bg/sum(prob_llhood_bg);
    prob_llhood_fg = prob_llhood_fg/sum(prob_llhood_fg);
    
    
end



