function obj = as_SetSegmentsValue(obj,option_set_value,solution,threshold)

% set the value (ON - 1, OFF - 0) for every segment sid in every image i
% based on the option_set_value
% if option_set_value = 'gt'      - then obj(i).segms(sid).set = obj(i).segms(sid).gt - use the gt selection
% if option_set_value = 'sol'     - then obj(i).segms(sid).set = solution(indice_sid) - where indice_sid indicates the corresponding position of the sid in the solution vector
% if option_set_value = 'random'  - then obj(i).segms(sid).set = rand()<threshold;

if strcmpi(option_set_value,'gt')
    for i = 1:length(obj)
        for sid = 1:length(obj(i).segms)
            obj(i).segms(sid).set = obj(i).segms(sid).gt;
        end
    end
    return 
end

if strcmpi(option_set_value,'solution')
    indice_sid = 0;
    for i = 1:length(obj)
        for sid = 1:length(obj(i).segms)
            indice_sid = indice_sid + 1;
            obj(i).segms(sid).set = solution(indice_sid);
            obj(i).segms(sid).fg = solution(indice_sid);
            obj(i).segms(sid).bg = 1 - solution(indice_sid);
        end
    end
    return 
end

if strcmpi(option_set_value,'random')    
    for i = 1:length(obj)
        for sid = 1:length(obj(i).segms)            
            obj(i).segms(sid).set = rand()<threshold;
        end
    end
    return 
end

display('Error: option_set_value unknown... segments value not set');




end