function solution = as_SolveProblemTRW(GM,solver)

GM = mgc_ToDoubleGM(GM);
if(strcmpi(solver,'trw'))
    
[L energy energy_lb] = vgg_trw_bp(GM.UE, GM.PI, GM.PE,int32([1 0 5000]));
solution = L-1;
else
    if(strcmpi(solver,'qpbo'))
        GM_qpbo = as_GmTrwToQpbo(GM);
        [solution stats] = vgg_qpbo(GM_qpbo.UE, uint32(GM_qpbo.PI), GM_qpbo.PE);
        unlabeled_nodes = find(solution < 0);
        display('number of unlabeled nodes after QPBO is');
        if isempty(unlabeled_nodes)
            display('0');
        else                        
            display(length(unlabeled_nodes));
        end
        if(~isempty(unlabeled_nodes)) %FUSE operation
            [L energy energy_lb] = vgg_trw_bp(GM.UE, uint32(GM.PI), GM.PE,int32([1 0 100]));
            sol_trw = L-1;
            solution(unlabeled_nodes) = sol_trw(unlabeled_nodes);
        end
    else
        display('Error: solver unknown');
        solution = [];
        return
    end
end
end