function prob = mgc_BuildModel(obj,bg_fg_option,option_compute_llhood,id_cell,updateBG)


% construct the vector of feature prob, prob(i) = P(feat_i|bg_fg_option)
% bg_fg_option is 'bg' or 'fg'
% compute the llhood vector using the fg_prior setting or the usual
% setting, using superpixels histograms;
if (nargin<3)
    option_compute_llhood = [];
end

if nargin < 5
    updateBG = [];
end

if strcmpi(option_compute_llhood,'fg_prior')
    field = ['hist_' bg_fg_option];
    A = [obj(:).prior_fg];%all images
    B = [A(:).(field)];  
    B = B(id_cell:(length(B)/length(A)):end);%update
    C = cat(2,B{:});
    D = ones(length(obj),1);
    E = C*D;
    if strcmpi(bg_fg_option,'bg')
        switch id_cell
            case 1
                struct = load('ModelBGOutsideBox_surf_100.mat');
            case 2
                struct = load('ModelBGOutsideBox_surf_1000.mat');
            case 3
                struct = load('ModelBGOutsideBox_ch_512.mat');
            otherwise
                display('Unknow option');
        end
        hist = struct.hist;
        E = E + hist;
    end
    prob = E/sum(E);%add epsilon ? numerical problems?    
    return
end
          

A = [obj(:).segms];%all segments
B = [A(:).hist];%all histograms
C = [A(:).(bg_fg_option)];
C = double(C);
B = B(id_cell:(length(B)/length(A)):end);
D = cat(2,B{:});
E = D * C';   
%update the Background using the Back model
if(strcmpi(updateBG,'updateOutsideBox'))
    %display('Updating BG using all the BG outside BOX');
    if strcmpi(bg_fg_option,'bg')
        switch id_cell
            case 1
                struct = load('ModelBGOutsideBox_surf_100.mat');
            case 2
                struct = load('ModelBGOutsideBox_surf_1000.mat');
            case 3
                struct = load('ModelBGOutsideBox_ch_512.mat');
            otherwise
                display('Unknow option');
        end
        hist = struct.hist;
        E = E + hist;
    end
end
prob = E/sum(E);
%size(prob)