function [boundary_sp img_boundary] = mgc_GetBoundaryFromSegments(img,verbose)

%img comes with a label for every segment
if nargin < 2
    verbose = 0;
end

boundary_sp = [];

segmLabels = unique(rowvec(img));
%nbLabels = length(segmLabels);

for id_label = 1:length(segmLabels)
   [r c] = find(img == segmLabels(id_label));%coordinates of the segment
   segms(id_label).coords = uint16([c'; r']);
   [segms(id_label).perimeter segms(id_label).perim_coords] = Perimeter(segms(id_label).coords);
end

for six1 = 1:length(segms)
    for six2 = (six1+1):length(segms);                    
        C1 = segms(:,six1).perim_coords;
        C2 = segms(:,six2).perim_coords;
        [~, dists2] = vgg_nearest_neighbour(double(C1), double(C2));
        ind_n = dists2==1;
        C1_n = C1(:,ind_n);
                
        [~, dists2] = vgg_nearest_neighbour(double(C2), double(C1));
        ind_n = dists2==1;
        C2_n = C2(:,ind_n);
        
        boundary_sp = [boundary_sp C1_n C2_n];
    end
end

img_boundary = zeros(size(img));

for id = 1:length(boundary_sp)
    img_boundary(boundary_sp(2,id),boundary_sp(1,id))=1;
end

if verbose
    figure;
    imshow(img_boundary);   
end
