function GM = mgc_GetPairwiseShape_reduced(obj,global_shape)

nb_images = length(obj);
img_segms = zeros(1, nb_images);

for i = 1: nb_images
    img_segms(i) = length(obj(i).segms);
end

total_segms = sum(img_segms);
NUMPW = total_segms * (total_segms-1)/2;

GM.state = 'Shape - pairwise';
GM.PI=zeros(3,NUMPW);   
GM.PE=cell(1,NUMPW);
GM.UE=cell(1,total_segms);

idx = 0;
%initialization - all 0
for img = 1:total_segms    
%     for jmg = img+1:total_segms        
%         idx = idx+1;
%         GM.PI(:,idx) = [img jmg idx];
%         GM.PE{idx} = single(zeros(2,2));
%     end    
    GM.UE{img} = double([0 0]);
end
GM.PI = uint32(GM.PI);

contor = 0;
for i = 1:nb_images        
    
    if isfield(obj(i).segms(1),'fg')
        img_reconstructed = mgc_DeriveImgFromSetSegms(obj(i),'fg');
        [~, img_boundary] = mgc_GetBoundaryFromSegments(img_reconstructed);
    else %first iteration - no segmentation yet
        [~, img_boundary] = mgc_GetBoundaryFromSegments(obj(i).segm_labels);
    end
    
    [dx dy] = gradient(img_boundary);
    %mag =sqrt(dx.^2 + dy.^2);
    phi = atan2(dy,dx);
    phi(phi<0) = phi(phi<0) + pi;
    
    for ii = 1: img_segms(i)-1
        for iii = ii+1 : img_segms(i)            
            if obj(i).adjacent(ii,iii)
               
                %derive the boundary between the 2 superpixels
                boundary_sp = [];
                C1 = obj(i).segms(:,ii).perim_coords;
                C2 = obj(i).segms(:,iii).perim_coords;
                [~, dists2] = vgg_nearest_neighbour(double(C1), double(C2));
                ind_n = dists2==1;
                C1_n = C1(:,ind_n);
                
                [~, dists2] = vgg_nearest_neighbour(double(C2), double(C1));
                ind_n = dists2==1;
                C2_n = C2(:,ind_n);
                
                boundary_sp = [boundary_sp C1_n C2_n];
                
%                 img_new = zeros(obj(i).pb);
%                 for idx = 1:size(boundary_sp)
%                     x = boundary_sp(2,idx);
%                     y = boundary_sp(1,idx);
%                     img_new(y,x) = 1;
%                 end
%                 img_resized = imresize(img_new,[]);

                %integrate over the boundary
                p = 0;
                boundary_sp = double(boundary_sp);
                for idx = 1:size(boundary_sp,1)
                    x = ceil((boundary_sp(1,idx)/size(obj(i).pb,2)) * size(global_shape,2));                    
                    y = ceil((boundary_sp(2,idx)/size(obj(i).pb,1)) * size(global_shape,1)); 
                    orient = ceil(phi(boundary_sp(2,idx),boundary_sp(1,idx))/(pi/size(global_shape,3)));
                    if ~orient
                        orient = 1;
                    end
                    p = p + global_shape(y,x,orient);
                end
                p = p/size(boundary_sp,1);
                mu = mean(mean(mean(global_shape)));
                pos_i_ii = sum(img_segms(1:i-1))+ii;
                pos_i_iii = sum(img_segms(1:i-1))+iii;                                
                %index = (pos_i_ii -1) * (total_segms - pos_i_ii/2) + (pos_i_iii - pos_i_ii);
                contor = contor + 1;
                %GM.PE{index} = single([0 mu-p;mu-p 0]);
                GM.PI(:,contor) = [pos_i_ii pos_i_iii contor]';
                GM.PE{contor} = double([0 mu-p;mu-p 0]);
            end
        end
    end
end

GM.PI = uint32(GM.PI);
GM.PI = GM.PI(:,1:contor);
GM.PE = GM.PE(1:contor);
