function prob_reg = regularize_probability_vector(prob_vector)

% sets all 0 components of prob_vector to a small value = minimum positive prob of prob_vector / 2 * (nb of component = 0) 
% example prob_vector = [0.5 0.4 0.1 0] then prob_reg = [0.5 0.4 0.1 0.05]

if(isempty(find(prob_vector == 0, 1)))
    prob_reg = prob_vector;
    return
end

prob_reg = prob_vector;
pos_idx = prob_vector>0;
min_prob_vector = min(prob_vector(pos_idx));
zero_idx = find(prob_vector == 0);
prob_reg(zero_idx) = min_prob_vector/(2*length(zero_idx));

