% surfDes  Extract SURF features from image
%
%     des = surfDes(i,pts,[thres=4.0], [doubleImage=false],
%     [customLobeSize=3], [sampling=2], [octaves=4], [upright=false],
%     [extended=false], [descriptorSize=4], [bLaplacian=true], [verbose=false])
%
% Uses the surf feature extraction code to obtain descriptors
% 
% This functions uses a mexified C++ interface to the surf library
% downloaded from ETH Zurich.
%
% IN:
%   i  HxW image (grey scale, double valued between 0 and 1)
%   pts Nx5 array of interest points in Mikolajczyk's format
%        -> see SURF documentation
%
% OUT:
%   des NxD array of descriptors
% 
% EXAMPLE:
%   feat=surfDes(im2double(rgb2gray(img)),grid,4,false,3,1,4,false,false,4,true,true);
%   default parameters, but with verbose
%
% Author: Thomas Deselaers <deselaers@vision.ee.ethz.ch> 
% created 2009-01-30 / last modified: 2009-01-30
