function [mask, labels, nLabels]=td_getShapeDescriptorMask(H,W,settings)

if settings.mask==1
    h=H/2; w=W/2;             % determine image center
    r=3+ceil(sqrt(h*h+w*w));   % determine radius such that the entire image fits into the used part of the mask
    
    mask=td_logPolarMasks(r,settings.rBins, settings.aBins);
    labels=unique(rowvec(mask));
    nLabels=settings.rBins*settings.aBins;
    
    firstpoint=floor((size(mask)-[H W])/2);
    mask=mask(firstpoint(1):firstpoint(1)+H-1, firstpoint(2):firstpoint(2)+W-1);
elseif settings.mask==2
    mask=reshape(1:(settings.xbins*settings.ybins),[settings.ybins, settings.xbins]);
    mask=imresize(mask,[H,W],'nearest');
    labels=unique(rowvec(mask));
    nLabels=settings.xbins*settings.ybins;
else
    error('unknown mask');
end