function [I, TL] = PaintCrop(P)

% paints set of points P on a new image I,
% exactly cropped on the BB of P.
%

% avoid overflow problems with P*size(I)
P = uint32(P);                                      

TL = min_matrix(P');                                % top-left point
BR = max_matrix(P');                                % bottom-right point
P(1,:) = P(1,:) - TL(1) + 1;
P(2,:) = P(2,:) - TL(2) + 1;

A = BR - TL + 1;                                    % cropped image coords
I = zeros(A(2),A(1));                               % actual cropped image

I(P(2,:) + (P(1,:)-1)*size(I,1)) = 1;  
