function STE = namg_get_STE_gmm( C, T, gmmf, gmmb, kf, kb, K_threshold )
[ nrows, ncols, ndims ] = size( C );
N = nrows * ncols;

% set the weights from the the source to the nodes and nodes to the sink
STE = zeros( 2, N );

idx = find( T > 128 );
STE( 1, idx ) = K_threshold;
%STE( 2, idx ) = 0; % not needed
idx = find( T < 128 );
%STE( 1, idx ) = 0; % not needed
STE( 2, idx ) = K_threshold;

idx = find( T == 128 );
kbidx = kb( idx );
for i = 1:length( gmmb.pi )
  idxi = find( kbidx == i );
  STE( 1, idx( idxi ) ) = ...
      -( ...
	  log( gmmb.pi( i ) ) + ...
	  nema_lognorm( nema_impixel( C, idx( idxi ) )', ...
			gmmb.mu( :, i ), gmmb.sigma( :, :, i ) ) ...
	  );
end

kfidx = kf( idx );
for i = 1:length( gmmf.pi )
  idxi = find( kfidx == i );
  STE( 2, idx( idxi ) ) = ...
      -( ...
	  log( gmmf.pi( i ) ) + ...
	  nema_lognorm( nema_impixel( C, idx( idxi ) )', ...
			gmmf.mu( :, i ), gmmf.sigma( :, :, i ) ) ...
	  );
end