% copied from nema_matte_grabcut for external use

function gmm = namg_init_gmm( C, nmixtures )
%% Initialize a GMM via vector quantization.
% 
% Input parameters:
%   C - Input image.
%   nmixtures - The number of mixtures.
%
% Output parameters:
%   gmm - A Gaussian mixture model structure.
[cluster, colours] = nema_vector_quantize( C, nmixtures );
for i = 1:nmixtures
  idx = find( cluster == i );
  gmm.mu( :, i ) = mean( C( :, idx ), 2 );
  gmm.sigma( :, :, i ) = cov( C( :, idx )' );
  gmm.pi( i ) = length( idx );
end
gmm.pi = gmm.pi / sum( gmm.pi );
